0.9.3
=====

New Features:

  * Convert parser limits for maximum transclusions, template depth and parser
    iterations to property values to allow more control for sites that need it.

Bugfixes:

  * Fix a potential infinite loop with nested template includes.  Inclusions
    are now limited to a maximum of 250 per page.
  * Setting the default file upload properties could cause initialization
    failures in cases where JAMWiki was deployed without the JAMWiki WAR, such
    as on the Liferay server.  Reported with proposed fixes by Igor Spasic.
  * The {{DISPLAYTITLE}} magic word should affect page title during editing
    and preview.  Reported by an anonymous user.


0.9.2
=====

New Features:

  * Update the LDAP sample in applicationContext-security.xml with an example
    of using LDAP for authentication and JAMWiki for role management.  Provided
    by Bobby Lawrence.

Bugfixes:

  * Fix list parsing for lists that end with </td> or </div>.
  * Fix the manual upgrade steps for namespace in the UPGRADE.txt document.
    Reported by an anonymous user.
  * Fix an issue in which non-image file uploads could fail on some operating
    systems.  Reported by an anonymous user.
  * Fix an invalid "You may not remove ROLE_SYSADMIN from your own account"
    message on the Special:Roles page when updating the sysadmin account.
  * Make sure all tables are properly migrated when using the
    Special:Maintenance "database migration" functionality.


0.9.1
=====

New Features:

  * Support added for the {{DISPLAYTITLE}} magic word.

Bugfixes:

  * __NOEDITSECTION__ was being improperly stripped from topics.
  * Fix a potental JDBC error with FORWARD_ONLY result sets when parsing
    deleted topics.  Reported by cmasuch.
  * Case-insensitive topic names and deleted topics were not being properly
    updated in the cache.
  * Exclude redirects when calculating the number of articles using the
    NUMBEROFARTICLES magic word.
  * Upgrade to Lucene Search 3.0.2 to resolve a LockObtainFailedException
    error.  Reported by TimStone.


0.9.0
=====

New Features:

  * Signficant updates to the syntax parser, including support for additional
    HTML tags and XHTML transitional validation of tag attributes.
  * New Special:VirtualWiki page for administering virtual wikis and
    namespaces, including the ability to configure translated / alternate
    namespaces and to change the default virtual wiki from "en".
  * Support the #if: and the #ifeq parser functions.  Usage:
    "{{#if: test | true | false}}" and "{{#ifeq: 1 | 2 | true | false}}".
  * Basic support for the #expr: parser function.  Only basic operations are
    supported (+, -, /, *) and parentheses must be used to ensure that the
    order of operations is followed.
  * Support added for the {{ns:}} and {{nse:}} parser functions.
  * Support Mediawiki's {{subst:}} syntax.  Usage: {{subst:template}}.
  * Support added for the __NOEDITSECTION__ behavior switch.
  * Support added for the {{NUMBEROFARTICLES}}, {{REVISIONUSER}} and
    {{REVISIONID}} magic words.
  * Add the ability for sysadmins to create user accounts (hanspeterklapf).
  * Topic add/update is now significantly faster due to query refactoring
    and changes so that the search index is not re-optimized after every
    add/update.
  * Topic history retrieval speed improved by a factor of up to 100x for
    large data sets by adding an additional database index.
  * Search engine optimizations.  Existing JAMWiki installs should rebuild
    their search index using the tools on the Special:Maintenance page.
  * "Filter results by namespace" added to Special:Allpages.
  * Update the CSS & HTML used for forms.  Requires StyleSheet topic update.
  * Support ehcache.xml configuration.  Based on code by Daniel Fisla (dfisla).
  * Automatically populate sample JDBC values based on database type on the
    setup and admin pages.
  * Remove all dependencies on Spring Security from the jamwiki-core project by
    converting org.jamwiki.model.Role to an interface and creating a new
    org.jamwiki.authentication.RoleImpl class.
  * Run the spam filter against edit comments as well as topic content to
    thwart spam attempts.
  * Update image parsing to match the latest Mediawiki standards, including
    support for "frameless", "link=", "alt=", "{width}x{height}" and the
    "Media:" namespace.
  * Allow parameters to be used when topics not in the template namespace are
    are utilized as templates.  Example: "{{myTopic|arg1=test1|arg2=test2}}".
  * Remove ability to automatically upgrade from versions prior to 0.7.0.
  * Move the database code into the jamwiki-core project.
  * All unit tests now use HSQL as a test database, rather than the dummy
    TestDataHandler.
  * Delete the webtest module, reducing the source code size by 12MB.
  * Remove the "export internal database to CSV" functionality - since it
    is now possible to export to XML and migrate databases this capability
    is no longer needed.
  * Highlight the currently selected tab on each page by adding an "active" CSS
    class.  Suggested by cstenkes.
  * Resize large images on Image: pages to a maximum dimension of 800x600.
  * Upgrade to Spring Framework 3.0.1.RELEASE.
  * Upgrade to Spring Security 3.0.2.RELEASE.
  * Upgrade to Lucene Search 3.0.1.
  * Upgrade to ehcache 1.7.0.
  * Upgrade to commons-pool 1.5.4.
  * Upgrade to JUnit 4.7.
  * Upgrade to HSQLDB 1.8.0.10.

Bugfixes:

  * Leading whitespace should be trimmed from category names such as
    "Category: Test" or "Category : Test".
  * Special:Import and Special:Export code refactored to avoid OOM errors with
    topics that have extensive history.
  * Properly parse template parameters that are themselves templates, such as
    "{{{{{template_name}}}}}" or "{{{1|{{PAGENAME}}}}}".
  * Process interwiki links only if the link does not contain a virtual wiki
    or namespace.  Thus if a wiki has a namespace of "Test" and an interwiki
    of "Test", the link "Test:Topic" will parse as an internal link rather than
    an interwiki link.
  * Trim leading and trailing whitespace during parsing when a template is
    included to fix breakage of wiki table syntax such as "!{{Hl2}}| Word".
  * Named template parameters should also be allowed to be referenced by
    index, for example "name={{{named}}}, index={{{1}}}".
  * The {{SITENAME}} magic word was not fully implemented, and returned
    "SITENAME" instead of the actual site name.
  * Links containing templates or magic words of the form "[[{{PAGENAME}}]]"
    should properly resolve the template/magic word.
  * If a namespace is not case-sensitive (user, template, category) then the
    associated comments namespace should not be case-sensitive either.
  * Interwiki links should not be rel="nofollow".
  * Links of the form "[[Help : Test]]" should link to the "Help:Test" page
    but output "Help : Test" as the link text, as per Mediawiki.
  * Fix parsing of nested links such as
    "[[Topic|caption with http://example.com link]]".
  * Wiki pre syntax (" pre <span>HTML</span>") should allow HTML, although
    HTML pre ("<pre>pre <span>HTML</span></pre>") should not.
  * Fix an issue that caused the original image URL (instead of the resized
    image URL) to be used for syntax such as "[[Image:Example.jpg|200px]]".
  * Use MEDIUMTEXT instead of TEXT for storing topic content on MySQL.  This
    increases the maximum allowed topic size from 64kb to 16MB.
  * Fix issues where image transparency was lost after resizing.
  * Fix issue that prevented use of wiki headings within tables.
  * The Bliki parser was not included in the distribution and thus could not
    be selected from the Special:Admin page.  Reported by cstenkes.
  * Fix parsing of links followed by quotation marks: "http://example.com".

Translation Updates:

  * Added Sinhala translations (ruchira56).
  * Updated German translations (axelclk).
  * Updated Hungarian translations (cstenkes).
  * Updated Polish translations (dlpa).
  * Updated Russian translations (shar).


0.8.4
=====

Bugfixes:

  * Wiki tables placed after lists were being incorrectly indented.  Reported
    by Rudi Wiesmayr.
  * Fix incorrect parsing when inline tags (such as wiki bold) are left
    unclosed before or after list tags.  Reported by Rudi Wiesmayr.
  * Parsing of the <references /> tag produced an unclosed ordered list.
    Reported by Rudi Wiesmayr and an anonymous user.
  * Fix potential XSS attack with URLs of the form Special:Login?message=XSS.
    Reported by frafu.
  * Fix the manual upgrade steps for MS SQL in the UPGRADE.txt document.
    Reported by Angel.
  * Very large values for max upload file size could result in
    NumberFormatException being thrown on the Special:Admin page.


0.8.3
=====

Bugfixes:

  * When renaming a topic, the data could be incorrectly stored in the database
    if the new topic name included an underscore or a plus sign.  Test case
    provided by Rudi Wiesmayr.
  * Links to a virtual wiki page with the same page name ("[[:test:PageName]]")
    will now parse correctly again.  Reported by Tom Schueller.
  * Update the default footer page's copyright notice to 2010.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated Dutch translations (Angel).
  * Updated German translations (axelclk).
  * Updated Russian translations (shar).


0.8.2
=====

New Features:

  * Updated spam filter patterns.
  * Update the default StartingPoints page with additional help info.

Bugfixes:

  * Fix MS SQL errors (hanspeterklapf).

Translation Updates:

  * Updated French translations (Guillaume_FRANCOIS55).
  * Updated German translations (axelclk).


0.8.1
=====

Bugfixes:

  * A link from a topic page to itself should be formatted as plain bold text,
    not as a link.  Reported by floatingworld.
  * XML imports of redirect topics were not redirecting properly.
  * Fix non-fatal MySQL upgrade warnings.  Reported by an anonymous user.
  * Fix code that could potentially leave database connections open during
    authentication.
  * Fix an issue that caused the Special:Maintenance "database migration"
    functionality to fail.
  * Templates will now be listed on Special:Allpages.  Reported by
    floatingworld.

Translation Updates:

  * Updated Chinese translations (tan9).
  * Updated Polish translations (dlpa).


0.8.0
=====

New Features:

  * Drop support for JDK 1.4.  Java 5 or later is now required to run JAMWiki.
  * Special:Import can now import Mediawiki files with full history, edit
    dates, and edit comments.
  * Special:Export can now export topics in Mediawiki format with full history,
    edit dates, and edit comments.
  * Mediawiki-style logs for uploads, user creation, etc are now available via
    the Special:Log page.
  * Add an optional "Show Changes" button during editing to display a diff
    view of the current edit.
  * Add diff highlighting for the portion of the line that changed (if any),
    similar to Mediawiki.
  * Allow an alternate file name to be specified as the "Destination Filename"
    when uploading, similar to Mediawiki.
  * Add links to the edited section in edit summaries on recent changes,
    history, etc, similar to Mediawiki.
  * Localize several messages in the upgrade process that were previously
    hard-coded in English.
  * Remove ability to automatically upgrade from versions prior to 0.6.0.
  * For databases that support it use auto incrementing primary keys during
    inserts to improve performance.  Suggested by Daniel Fisla (dfisla).
  * Implement caching for diffs, user information and topic versions to speed
    up page rendering.
  * Allow the HTML pre tag to be used with attributes (suggested by Skotty).
  * Refactor exception handling to throw and catch exceptions at a more
    granular level.
  * Allow JAMWiki properties to be read from outside of the WAR file or from
    system properties (urpi).
  * Allow authentication with pluggable Spring authentication modules that
    do not implement UserDetailService such as existing JAAS modules (urpi).
  * When a password or other value is found un-encrypted in a properties file
    automatically encrypt it to allow for changing database passwords, etc.
    Reported by rebecca and an anonymous user.
  * Move upgrade SQL to property files rather than hard-coding in Java code.
  * Make the site name a configurable property rather than a message key.
  * Upgrade to Spring Security 2.0.5.
  * Upgrade to javadiff 1.1.0.
  * Upgrade to JFlex 1.4.3.
  * Upgrade to JUnit 4.5.
  * Upgrade to JSTL standard taglib 1.1.2.
  * Upgrade to ehcache 1.6.0.

Bugfixes:

  * Update Spring Security configuration to remove reliance on the deprecated
    FilterInvocationDefinitionSourceEditor class.
  * Fix the Bliki local Maven repository metadata to resolve build warnings.
  * Do not use the category sort key for display purposes, only for sorting,
    which is consistent with Mediawiki.  Reported by hanspeterklapf.
  * Allow use of magic words and templates in category sort keys, such as
    [[Category:Test|{{PAGENAME}}]].
  * Throw an error when trying to rename images or categories with topic names
    that do not contain the "Image:" or "Category:" namespace.
  * Viewing a topic that is currently a redirect from its history page should
    not redirect.
  * Templates containing signature were displaying the signature for the user
    viewing the page, rather than the user who saved the page.  Example:
    {{template-name|~~~~}}
  * Use the wiki system directory for temp file storage in ImageIO processing
    to prevent errors on misconfigured systems.  Reported by jfbraz.
  * Validate that properties which must be numeric are set as numbers from
    Special:Admin.
  * When deleting, undeleting, or moving a page, if the "delete associated
    comments page" box was checked a NullPointerException would be generated
    for topics with non-ASCII topic names.
  * Template parameter names should ignore whitespace so that
    {{template|name=foo}} is the same as {{template|  name = foo}}.  Reported
    by floatingworld.
  * Do not allow creation of topics that start with "/" or that are of the form
    Namespace:/Topic.
  * Category topics displayed inconsistently in the topic view, print view and
    editing preview view.
  * "File History" on Image: pages should also display author information.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated French translations (Guillaume_FRANCOIS55).
  * Updated German translations (axelclk).
  * Updated Japanese translations (nattolover).
  * Updated Polish translations (dlpa).
  * Updated Russian translations (shar).


0.7.2
=====

New Features:

  * Updated spam filter patterns.

Bugfixes:

  * Fix missing edit toolbar during preview.  Reported by hanspeterklapf.
  * Fix MS SQL error when searching for user contributions (hanspeterklapf).
  * Fix MS SQL upgrade errors (hanspeterklapf).
  * Fix "array index '1' is invalid" error during setup with Resin 3.2.1.
    Reported by James.
  * Fix TOC rendering issue when depth exceeds the configured max depth.
  * Fix double-escaping of non-existent topic names when using URLs such as
    http://jamwiki.org/wiki/en/TestÜmlaut.  Reported by hanspeterklapf.
  * Fix breakage when moving topics containing special characters such as
    "TestÜmlaut".  Reported by hanspeterklapf.
  * Display any editable category topic text above the list of category items.
    Reported by axcelclk.
  * Fix failures when upgrading from versions earlier than 0.6.0.  Reported by
    Eric.
  * Groups were not being displayed on the Special:Roles page when no roles were
    assigned to the group.  Reported by hanspeterklapf.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated French translations (Guillaume_FRANCOIS55).
  * Updated Russian translations (shar).


0.7.1
=====

New Features:

  * Upgrade to Lucene Search 2.4.1.

Bugfixes:

  * Search by login on the Special:Roles page returned no results for users
    without at least one role.  Reported by tapaya and rebecca.
  * Fix incorrect LDAP sample configuration.  Reported with a fix by Tobias
    Kalbitz.
  * Display signatures even if there is no email addresss specified (axelclk).

Translation Updates:

  * Added Russian translations (shar).
  * Updated German translations (axelclk).
  * Updated Portugese (Brazilian) translations (leandes).


0.7.0
=====

New Features:

  * Login and authentication completely rewritten to take better advantage
    of Spring Security capabilities.
  * Special:OrphanedPages added to display un-linked pages (hanspeterklapf).
  * Remove ability to automatically upgrade from versions prior to 0.5.0.
  * "Next" and "prev" diff links added to Special:History to match Mediawiki.
  * Number of characters changed in a diff is now displayed on recent changes,
    history and other pages to match Mediawiki.
  * Signficant (5-10x or more) performance improvement of image rendering by
    making better use of cache.  Suggestions from Jim.
  * Allow users to create custom signatures, rather than using the same
    signature pattern for all users.
  * Modify Special:Specialpages so that it is localized for each visitor,
    rather than always defaulting to the language for which the wiki was setup.
  * Provide the capability to redirect to a virtual wiki using syntax of the
    form "#REDIRECT [[:virtual:Topic]].  Requested by tfschueller.
  * Login will now always take the user back to the page from which 'login' was
    clicked, as requested by many users and as implemented by Mediawiki.
  * Allow updating of account information on Special:Register without entering
    the old password EXCEPT when changing password.
  * Update CSS / HTML to use semantic code when possible - no visible changes.
  * Update the UI of the upgrade screen to provide additional information.
  * Initial implementation of Mediawiki parser functions including
    anchorencode, filepath, fullurl, localurl, lc, lcfirst, uc, ucfirst and
    urlencode.
  * Add support for the {{SERVERNAME}} and {{SERVER}} magic words.
  * Allow nesting of templates ("{{template1|content={{template2}}}}").
  * Support categories on #REDIRECT pages to match Mediawiki.
  * Add "H2" as a database configuration option.
  * Updated spam filter patterns.
  * Upgrade to Lucene Search 2.4.0.
  * Upgrade to Spring Framework 2.5.6.
  * Upgrade to Spring Security 2.0.4.

Bugfixes:

  * Fix category pagination when using MS SQL (hanspeterklapf).
  * Fix broken links to Lucene search help on the search page (hanspeterklapf).
  * Ensure that URI parameters of the form ";jsessionid=1234" are not included
    in topic names.  Affects Jetty and possibly other containers, reported by
    spiralmike.
  * Use a default MIME type of "application/unknown" for file uploads without
    MIME types to prevent database errors.  Reported by Tim.
  * Fix incorrect paragraph parsing when there is a blank line containing
    one or more whitespace characters between the paragraphs.  Reported by
    James Teer.
  * Fix parsing of multiple newlines to match Mediawiki.
  * Fix parsing of links containing parantheses such as
    http://example.com/page_(page).  Reported by  Michael Habbert.
  * Fix parsing of nested tags of the form <tt><tt>test</tt></tt> which were
    producing an extra closing tag.
  * Fix issues with the database migration code that could cause failures
    when migrating categories or migrating very large data sets.
  * Fix a case-sensitivity issue when building on UNIX machines (marcust).
  * If the file for an Image: link cannot be found on the filesystem generate
    an upload link rather than throwing an exception and silently hiding the
    image from the front-end.

Translation Updates:

  * Added Portugese (Brazilian) translations (leandes).
  * Updated Chinese translations (hfl).
  * Updated German translations (axelclk).


0.6.7
=====

New Features:

  * None

Bugfixes:

  * JDK 1.6 and greater changed the behavior of the JDBC getColumnName() method
    causing the watchlist tab to break.  Fix suggested by Luc.
  * Virtual wiki default topics with spaces were incorrectly being stored with
    spaces converted to underscores ("Main_Page" instead of "Main Page").
  * Null pointer exception when viewing URLs with no topic and no trailing
    slash of the form "/context/virtual".
  * A bug introduced in a previous release prevented empty topics from being
    saved - this is now fixed.
  * Links of the form [[#section]] and [[#section|text]] will now be parsed
    correctly.
  * Fix broken parsing of links containing + such as [[start + end]].  Reported
    by MarioF.
  * Fix broken parsing of wiki preformatted text that follows a paragraph.
    Reported by tfschueller.
  * Numerous fixes for issues related to umlauts (ü) and other special
    characters in topic and section names.  Reported by ihbrune.
  * Editing a section of a topic did not always redirect back to that section
    after saving the topic in cases of section names with umlauts or other
    special characters.
  * Resolve a CSS issue that impacted edit links on IE6.  Reported by an
    anonymous user.
  * Resolve a CSS issue that impacted images with frames on IE6.  Reported by
    an anonymous user.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated Japanese translations (nattolover).
  * Updated Polish translations (dlpa).
  * Added Slovakian translations (aryan).
  * Updated Swedish translations (martin).


0.6.6
=====

New Features:

  * Significant modifications to the parser to simplify the code, fix
    bugs, and ensure that output is as close as possible to that of Mediawiki.
  * Use Spring-managed transactions for database connections (dallas).
  * Utility added to Special:Maintenance to allow administrators to reset user
    passwords.
  * Utility added to Special:Maintenance to allow administrators to export
    internal database data to CSV.
  * Utility added to Special:Maintenance to allow administrators to migrate
    data from one database to another (dallas).
  * The Special:History page now implements the same UI as Mediawiki with radio
    buttons instead of checkboxes.
  * Unit test coverage has been significantly improved.
  * Support added for definition lists of the form "; term : definition".
  * Support added to allow use of HTML list tags ("ol", "dl", "dt", "li", and
    "ul").
  * Support added for plural wiki links of the form [[Topic]]s.  Suggested by
    axelclk.
  * Sub-headings in the table of contents should be of the form "1.1.1" to
    match Mediawiki.  Reported by Sil68.
  * Updated spam filter patterns.
  * Upgrade to the Bliki 3.0 parser (axelclk).
  * Upgrade to Spring Framework 2.5.4.
  * Upgrade to Spring Security 1.0.7.
  * Upgrade to Lucene Search 2.3.2.
  * Upgrade to commons-lang 2.4.

Bugfixes:

  * Unbalanced / unclosed HTML tags will now be automatically closed by the
    parser.  Originally reported by Michael Habbert.
  * Fix an issue that prevented error messages from being correctly reported on
    the Special:Maintenance page.
  * Resolve a problem that prevented __TOC__ tags within tables from being
    processed.  Reported by an anonymous user.
  * Wiki table captions now process table CSS such as |+align="bottom"|caption.
    Reported by an anonymous user.
  * Image files were being cached unnecessarily, leading to excessive memory
    use.  Reported by Jim.
  * Underscores in template names should be ignored so that {{Template Name}}
    and {{Template_Name}} are seen as equivalent.  Reported by yesesnono.
  * Fix an issue where in some cases (most commonly after server restarts) a
    remembered user could be incorrectly loaded as a null user.

Translation Updates:

  * Updated Danish translations (g9adm).
  * Updated German translations (axelclk).
  * Updated Japanese translations (nattolover).


0.6.5
=====

New Features:

  * Support added for Sybase ASA (dallas).
  * The spam filter will now also check descriptions for uploaded files in
    order to block spam from bots using this path.
  * Updated spam filter patterns.

Bugfixes:
  * Fix a problem that could cause HSQL to generate locking errors on context
    reload (dallas).
  * Resolve a problem that could cause database connection lockups during
    setup on MS SQL and some other databases.  Reported by multiple users, with
    significant debugging help provided by dallas.
  * Fix a regression that broke the Special:Manage page.  Bug reported with a
    suggested fix by tfschueller.
  * Fix a regression that broke the Special:Move page (dallas).
  * Resolve a logic error that prevented topics from being retrieved from the
    cache at appropriate times.  Pointed out by Jim.
  * The "Special" tab on the Special:Contributions page did not have the
    correct URL.  Reported by yesesnono.

Translation Updates:

  * Updated Hungarian translations (bdanee).


0.6.4
=====

New Features:

  * Update and reorganize the monolithic jamwiki project structure into the
    more modular jamwiki-core, jamwiki-web and jamwiki-war sub-projects.  As
    a result of this change it is now possible to use the JAMWiki parser as a
    standalone library.
  * Update the parser to generate syntax that more exactly matches the parsed
    HTML output of Mediawiki.
  * Significantly improve the JAMWiki unit-test coverage.
  * Ignore line feeds in diffs to prevent showing changes due only to file
    format differences.
  * Add an option to view only untranslated keys on the Special:Translation
    page.
  * Upgrade to Lucene Search 2.3.1.
  * Updated spam filter patterns.

Bugfixes:

  * Resolve broken parsing of Javascript tags for wikis that have enabled the
    "allow Javascript" option.  Reported by ksdprasad.
  * Resolve potential issues with invalid URLs that contain multiple "/"
    characters such as http://example.com/wiki//en/StartingPoints.  Reported
    with a suggested fix by an anonymous JAMWiki user.
  * Resolve an issue that prevented viewing user contributions for users with
    logins containing underscores.  Reported by yesesnono.
  * Add field-length checks to all database inserts/updates and either trim the
    field or report an error when a field exceeds the maximum allowed length.
  * Fix an issue that prevented template <noinclude> and <includeonly> sections
    from displaying templates, signatures, and other content that requires
    parser pre-processing.  Reported by ean.
  * Category pages were previously displaying only images, articles, and
    sub-categories, leaving out templates.  Reported by ean.
  * Links of the form [http://example.com '''Bold text'''] will now properly
    parse markup for the link caption.
  * Fix a parser issue that could cause wiki tables to be generated with
    missing opening <tr> tags.
  * Add topic name validation to uploaded image files.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated Dutch translations (Angel).
  * Updated German translations (axelclk).


0.6.3
=====

New Features:

  * Upgrade to Spring Framework 2.5.1.
  * The Special:Translation page will now default to the user's default
    language instead of defaulting to English.
  * Upgrade to Acegi Security 1.0.6.
  * Add support for IPv6 to prevent database errors on IPv6 systems.  Problem
    reported by huntc.

Bugfixes:

  * Umlauts, ampersands and other special characters were being double-escaped
    in the user menu.  Bug reported by Толик.
  * Resolve a CSS issue that impacted display of diffs.  Reported by legendsen.
  * When an access denied message is displayed make sure that the login page
    displayed is in the same virtual wiki as the orginal page request.  Bug
    reported by Feilong Huang.
  * Fix several potential (although unlikely) NPE scenarios identified by
    static code analysis tools.
  * Update the CSS for pre tags to prevent overflows in tables.  Reported by
    Michael Habbert.
  * Fix a bug that broke the Special:Contributions when using a non-ASCII user
    login.

Translation Updates:

  * Updated Dutch translations (Angel).
  * Added Galician translations (mmeixide).
  * Updated German translations (axelclk).
  * Updated Japanese translations (nattolover).
  * Added Portugese translations (mmeixide).
  * Updated Spanish translations (AngelPinazo & mmeixide).


0.6.2
=====

New Features:

  * Upgrade project dependencies to Servlet 2.4 and JSP 2.0.  Bugs in previous
    JAMWiki configuration settings required these dependencies, so this change
    should be backwards-compatible.
  * Upgrade to JSTL 1.1.2 (from 1.0.6).
  * Make the valid login, topic name, and role name patterns configurable.
  * Replace several custom methods with the org.apache.commons.lang equivalent.
  * During setup, create a default directory to use for image and other file
    uploads to hopefully eliminate some confusion.
  * When using multiple references to the same source, use the first non-empty
    reference definition instead of using the first reference definition.
  * Make the search engine instance a configurable parameter.
  * Remove the unnecessary "Are you sure" prompt when upgrading.
  * Use JFlex Maven plugin instead of Ant task (RegisDecamps).
  * Updated spam filter patterns.

Bugfixes:

  * Resolve a CSS issue that caused the TOC to be invisible on IE6.  Reported
    by bvold.
  * Umlauts, ampersands and other special characters were being double-escaped
    in the TOC.  Fix contributed by Louis Martin.
  * Fix issue where search terms were double-escaped when no search results
    were found.
  * Reload data handler and other values after upgrade to (hopefully) avoid
    problems with incorrect data handler instances.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated German translations (axelclk).
  * Updated Polish translations (dlpa).
  * Updated Spanish translations (AngelPinazo).


0.6.1
=====

New Features:

  * Look & feel updates including replacing HTML tables with divs.
  * Special:Translation now displays the original English message string as a
    label.
  * Upgrade to Spring Framework 2.0.7.
  * Upgrade to Acegi Security 1.0.5.

Bugfixes:

  * "Open printable link in new window" functionality was broken in 0.6.0.  Bug
    found and fix suggested by Ernesto Arteaga (arterzatij@radioactivo.com) and
    Esteban Dueas (edvjar@hotmail.com).
  * Fix an issue where redirection from index.jsp would lead to the wrong topic
    when the default topic has previously been changed.
  * Allow access to CSS and JAMWiki images even if a user does not have
    ROLE_VIEW.  This change prevents display issues on the Special:Login page.
  * Fix an issue with DB2 installation by trimming all SQL constraint names to
    less than 18 characters.
  * If two entries in the TOC have the same text make sure that the links do
    not always go to the first entry.
  * Fix parsing of TOC values containing wiki markup.
  * Better handle cases of mis-indented TOC (for example, h2 followed by h4).
  * ROLE_DELETE is the same as ROLE_ADMIN and has been removed.
  * Add a dummy query parameter to the jamwiki.css link to avoid browser
    caching issues that could cause old CSS to be displayed.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated German translations (frareinif).
  * Updated Japanese translations (nattolover).


0.6.0
=====

New Features:

  * New infrastructure for assigning fine-grained user permissions, including
    a new Special:Roles administrative interface.
  * User pages now offer a "User Contributions" tab that displays all
    contributions made by the user (RegisDecamps).
  * Project converted to use Maven (RegisDecamps & mikegr).
  * New Special:ImportTiddly page for importing from TiddlyWiki (mikegr).
  * Update the UI used in the wiki admin pages.
  * Remove ability to automatically upgrade from versions prior to 0.4.0.
  * Remove the unused & deprecated Special:Convert admin page.
  * Updated spam filter patterns.
  * Apostrophes are no longer automatically converted to &#39;. (RegisDecamps).
  * Image resizing uses a smaller resize increment, improving image quality.
  * Upgrade to Spring Framework 2.0.6.
  * Upgrade to Acegi Security 1.0.4.
  * Upgrade to ehcache 1.3.0.
  * Upgrade to Lucene Search 2.2.

Bugfixes:

  * Fix issue on Tomcat 5 & some other application servers that could cause
    corrupted topic names when editing non-ASCII topics.
  * Fix web.xml issue when using Glassfish application server (amerigo5).
  * Resolve a JNDI database connectivity issue (mnencia).
  * Fix an issue related to the SHA-512 algorithm that broke installations
    on JDK versions prior to 1.4.2.
  * UNIX systems without X could crash on image resizing.  Modify error
    handling to catch Throwable rather than Exception and log a message
    explaining how to work around this particular issue.  Reported and
    debugged by Michael Osipov, who also provided a suggested fix.
  * Fix parsing of bold italic ('''''), which produced incorrect HTML in
    previous releases.  Reported by RegisDecamps.
  * Oracle stores empty strings as NULL, which causes breakage with empty
    topics.  Issue should now be resolved.
  * Wiki signatures could generate incorrectly for users without display names.
  * Fix missing apostrophe in SQL used by MS SQL when displaying the
    Special:Listusers pages.  Reported by yesesnono.
  * Fix incorrect constraint in SQL used by MS SQL that prevents recreating
    topics that have been deleted.  Reported by yesesnono.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Added Croatian translations (Marija Susovic).
  * Updated Danish translations (g9adm).
  * Updated Dutch translations (Angel).
  * Updated German translations (axelclk & frareinif).
  * Updated Japanese translations (nattolover).
  * Updated Polish translations (dlpa).


0.5.4
=====

New Features:

  * Upgrade to Spring Framework 2.0.4.
  * Upgrade to commons-dbcp-1.2.2.jar.
  * Upgrade to Lucene Search 2.1.
  * Add Special:Listusers page to display a list of all wiki users.
  * Add option to open external links in a new window.

Bugfixes:

  * Templates containing categories within <includeonly> or <noinclude> tags
    should now work properly.
  * Updating Special:Admin no longer refreshes search index to avoid
    performance issues.
  * Resolve TLD issues that caused errors with Tomcat 5.5 with Debian Etch.

Translation Updates:

  * Updated Dutch translations (Angel).
  * Updated German translations (axelclk).
  * Updated Polish translations (dlpa).


0.5.3
=====

New Features:

  * Upgrade to Spring Framework 2.0.3.
  * Hide edit tab from users who do not have permission to edit a topic.

Bugfixes:

  * Fix an error with Resin that could result in ClassCastException on pages
    displaying "diff" links.
  * Equal signs within headings ("=== foo = bar ===") parsed incorrectly.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated Dutch translations (Angel).
  * Updated German translations (axelclk).
  * Updated Japanese translations (nattolover).
  * Updated Polish translations (dlpa).

0.5.2
=====

New Features:

  * Add the option to whitelist/blacklist allowed file upload types.
  * Upgrade to commons-io-1.3.1.jar.
  * Upgrade to commons-fileupload-1.2.jar.
  * When displaying a "topic does not exist" message, also include a link to
    create the topic.
  * Update look & feel - do not underline links, add fieldset tags.
  * Split the main admin page into Special:Admin and Special:Maintenance.
  * Hide the Special:Convert admin page.
  * Add an option to clear the cache from Special:Maintenance.
  * Added automatically generated JUnit tests from junitfactory.com.

Bugfixes:

  * Certain topic names could cause errors resulting in CPU usage of 100%.
  * Fix build error where build would fail if local files directory did not
    exist.

Translation Updates:

  * Updated Chinese translations (hfl).
  * Updated German translations (axelclk).
  * Updated Hungarian translations (bdanee).
  * Added Japanese translations (nattolover).
  * Updated Polish translations (dlpa).

0.5.1
=====

New Features:

  * Initial spam filter support.
  * Upgrade to Spring 2.0.2.
  * Simplify the process for creating new Wiki "Special:" pages to hopefully
    make it easier for development of custom pages.
  * RSS updates (swift).

Bugfixes:

  * Fix infinite redirect problem when installing with BEA WebLogic.
  * Logo image not appearing on sub-pages (such as "Topic/Sub-Topic").
  * Fix problem with images not being properly resized.
  * Fix webAppRootKey error when multiple JAMWiki instances installed on the
    same server (swift).

Translation Updates:

  * Updated Chinese translations (ewen0930).
  * Updated Danish translations (g9adm).
  * Updated Chinese translations (hfl).

0.5.0
=====

New Features:

  * Add ehcache library for caching of parsed topics and images.
  * Integrate the Acegi security framework (swift).
  * Add experimental support for LDAP.
  * Add experimental RSS support (swift).
  * Allow users to select a default locale (swift).
  * Consolidate configuration values into jamwiki-configuration.xml.
  * Add option to use WYSIWYG edit buttons (axelclk).
  * Add Special:Imagelist page to display a list of all images.
  * Add Special:Filelist page to display a list of all non-image files.
  * Experimental Special:Import XML import (gutsul).
  * Add support for the __FORCETOC__ tag.
  * Handle category names case-insensitive, thus "Category:Test" and
    "Category:test" are treated as the same category.
  * Display current date & time on Special:RecentChanges page.
  * Upgrade to Spring Framework 2.0.1.
  * Remove (now unused) convert-to-file option from Special:Convert.
  * Include the Bliki parser as an alternative to the default parser
    (axelclk).
  * Add access keys for edit page fields (axelclk).
  * Add option to open "printable page" links in a new window.
  * Add a check to verify a supported JDK version during setup.
  * Add pmd static code analysis target to the ANT build.xml file.

Bugfixes:

  * Fixes for MS SQL issues (scroco).
  * "Login already exists" error when trying to update user account fixed.
  * Fix upload error with IE that could cause file upload to incorrectly set
    the file name.
  * The __TOC__ should force a table of contents to appear, even with fewer
    than four headings.
  * Do not allow users without proper permissions to move read-only or
    admin-only topics.
  * Properly log messages from Utilities and with configured log levels.
  * Resolve problems with unreliability in deletion/undeletion.
  * Fix failure when changing default topic for virtual wiki from
    Special:Admin.

Translation Updates:

  * Added Dutch translations (Angel).
  * Added Ukranian translations (gutsul).
  * Updated Chinese translations (hfl).
  * Updated Polish translations (dlpa).
  * Updated German translations (axelclk).
  * Updated Hungarian translations (bDaneE).
  * Updated French translations (hgomez).

0.4.3
=====

New Features:

  * Add support for Mediawiki <ref> tag as described on
    http://meta.wikimedia.org/wiki/Help:Footnotes.
  * Add "Watch Topic" checkbox when editing.
  * Add "Special:Specialpages" page.
  * Improve support for localized default topics.
  * Add support for setting HTML meta values.

Bugfixes:

  * Do not HTML escape &lt; and &gt;.
  * Fix issue with non-ASCII file descriptions.

Translation Updates:

  * Updated Polish translations from Robert Matyja (dlpa).
  * Updated Hungarian translations from Daniel Tar (bDaneE).
  * Updated Danish translations from Anders Monrad (g9adm).

0.4.2
=====

New Features:

  * Add support for watchlists as described on
    http://meta.wikimedia.org/wiki/Help:Watching_pages.
  * AdminOnlyTopics replaced by Special:TopicsAdmin.
  * Upgrade to Spring Framework 2.0.
  * "Go To" button in search should redirect to search results if no such
    topic exists.
  * Be more efficient with caching to improve performance.
  * Add a checkbox to Special:Manage to delete/undelete an associated
    comments page.
  * Provide an option to set maximum table of contents depth.
  * After editing a section, page will now reload to that section.
  * Remove option to disable topic versioning.
  * Update default start page text.

Bugfixes:

  * Refreshing after a form submission should no longer cause information
    to be resubmitted.
  * Fix parsing error when template parameters are preceded by whitespace.
  * Fix error when uploading files with non-English file names.
  * Recompile the HSQL JAR file to allow use with JDK 1.4.
  * Some unhandled exceptions could cause confusing error messages to be
    shown to the user, now fixed.
  * JUnit 4.1 requires JDK 1.5, downgrade to JUnit 3.8.2.

Translation Updates:

  * Updated Polish translations from Robert Matyja (dlpa).
  * Updated Hungarian translations from Daniel Tar (bDaneE).

0.4.1
=====

Bugfixes:

  * Fix a setup bug that could incorrectly report that a database already
    exists.

0.4.0
=====

New Features:

  * Add support for Mediawiki templates (see
    http://meta.wikimedia.org/wiki/Help:Templates).
  * Replace file persistency mode with an embedded version of the HSQL
    database.
  * Major update to the JAMWiki parser code.
  * Updated interwiki file from Axel Kramer (axelclk).
  * Process interwiki prefixes case-insensitive.
  * Remove ability to automatically upgrade from JAMWiki versions prior to
    0.2.0.
  * Require admin user login to perform an upgrade.
  * Remove Special:AllTopics; it was replaced by Special:Allpages in JAMWiki
    0.3.0.
  * Add JUnit test framework.
  * Change default logo to submission from Oliver (okohll).
  * Add additional support for the DB2/400 database.
  * Updated MS SQL support from Robert Matyja (dlpa).

Bugfixes:

  * Properly escape ampersands from the parser to ensure XHTML output.
  * "Move" tab being incorrectly hidden on topic pages.
  * Resolve issues that could cause upgrades to fail.
  * Fix possible database transaction blocking during setup using
    suggestions from Robert Matyja (dlpa).

Translation Updates:

  * Updated Hungarian translations from Daniel Tar (bDaneE).
  * Updated Polish translations from Robert Matyja (dlpa).
  * Updated German translations from Axel Kramer (axelclk).

0.3.6
=====

Bugfixes:

  * Fix setup.jsp typo that caused compile errors.

Translation Updates:

  * Updated Hungarian translations from Daniel Tar (bDaneE).
  * Updated Polish translations from Robert Matyja (dlpa).
  * Updated Chinese translations from ewen0930.
  * Added French translations from Henri Gomez (hgomez).

0.3.5
=====

New Features:

  * Add support for topics of the form "Topic/Subtopic".
  * Support for interwiki links ([[Wikipedia:Main Page]]).
  * Re-engineer link handling to simplify the code.
  * Add pagination support.
  * Use the file system, not RAM, when rebuilding search index.
  * Remove VQWiki parser - unsupported.
  * Simplify the parser by removing the pre-save parser.
  * Remove ability to upgrade from JAMWiki versions prior to 0.1.0.
  * Add ANT target for building Javadoc.
  * Add experimental support for the DB2, DB2/400 and MSSQL databases.

Bugfixes:

  * Fix error on Special:Categories when in file persistency mode.
  * Allow signatures in image captions.
  * Table of contents should be enabled by default.

Translation Updates:

  * Updated Polish translations from Robert Matyja (dlpa).
  * Updated German translations from Axel Kramer (axelclk).

0.3.4
=====

New Features:

  * Make signature patterns configurable.
  * Display comments and contributions links on history page.
  * Split up recent changes page by date.
  * Use java.util.logging for logging, remove log4j.
  * Display "n" on changes pages for new topics.
  * Do not display redirect syntax as an ordered list.
  * Add the capability to move a page over an existing redirect.
  * Allow additional symbols such as quotation marks in topic names.
  * Be more restrictive about characters allowed in user logins.
  * Validate system settings during upgrades.
  * Add instructions for performing a manual upgrade.
  * Clean up the layout of the Special:Admin page.
  * Sort property values alphabetically.
  * Add validation checks to Special:Admin.
  * Add additional validation checks to Special:Setup.
  * Remove beta warning from the Special:Translation tool.

Bugfixes:

  * Correctly parse table cells that contain links of the form [[Topic|Text]].
  * Fix issue with shared library files not being loaded.
  * Modify search engine initialization to avoid setup errors.
  * Correctly maintain file history when redirecting using file persistency.
  * Topic names containing percent signs ("%") caused errors.  Fixed.
  * Do not display option to change user login in Special:Account.

Translation Updates:

  * Updated Hungarian translations from Daniel Tar (bDaneE).
  * Updated Chinese translations from ewen0930.
  * Updated German translations from Axel Kramer (axelclk).
  * Added Polish translations from Robert Matyja (dlpa).

0.3.3
=====

Bugfixes:

  * Internet Explorer displays &apos; instead of apostrophe (').
  * Resin taglib handling throws an error on wiki.jsp.
  * Second attempted fix for reported URL decoding issue.

Translation Updates:

  * Updated Hungarian translations from bDaneE.

0.3.2
=====

Bugfixes:

  * Upgrades in file persistency mode fail due to delete date change.
  * Do not include parentheses in raw links when parsing.

0.3.1
=====

New Features:

  * FEATURE: Add support for Mediawiki redirects (#REDIRECT [[Topic]]).
  * FEATURE: Add Special:Move.
  * FEATURE: Add jamwiki:linkParam tag, remove jamwiki:encode and
    jamwiki:decode tags.
  * FEATURE: For non-image files, [[Image:File]] should display as a download
    link.
  * FEATURE: Uploading a second version of an image should add a record to the
    recent changes.
  * FEATURE: Updates made using Special:Translation will now add a record to
    the recent changes page and save a version of the translated file.

Bugfixes:

  * Apostrophes were not being escaped by the parser.
  * <pre> tags might not be closed by the parser.
  * Use of the edit resolve functionality with a section edit could cause the
    resulting edit to splice together too much text.
  * Upgrade could fail if no user logged in.  Reported by colinbes.
  * Login page displayed the wrong login message.
  * Do not allow user names that vary only by case ("user" vs. "uSer").
  * Fix issue with browsers that encode URL as UTF-8 instead of ISO-8859-1.
  * Remove extra "/" that could sometimes appear in image URLs.
  * Fix topic undeletion when in file persistency mode.
  * Do not display option to change permissions if topic is deleted.

Translation Updates:

  * Danish translations from Anders Monrad (g9adm).
  * Updated German translations from Axel Kramer (axelclk).
  * Updated Hungarian translations from bDaneE.

0.3.0
=====

New Features:

  * Add support for Mediawiki categories.
  * Add Special:Categories.
  * Add Special:Manage, remove Special:Delete.
  * Add support for undeleting a topic.
  * Drop jam_image table - unused.
  * Major parser architecture updates.  Parser should be slightly faster when
    parsing edits.
  * Fix reloading of recent changes in ANSI database mode.
  * Special:AllTopics renamed to Special:Allpages for Mediawiki compatibility.
  * Delete activation.jar - unused.
  * Code cleanups including removal of unused files.

Bugfixes:

  * Possible null pointer exception in file persistency mode, pointed out by
    User:garem.
  * Image uploads in file persistency mode set wrong path.
  * Fix possible PageInfo corruption.  Pointed out by Scott Crocco.
  * Upgrade to javadiff 1.0.5 to fix several diff issues.
  * Parser was not parsing links of the form [[#Section]] properly.
  * Parser was not parsing links with parentheses (such as
    [[Ajax (programming)]]) properly.
  * Some file input/output streams not properly closed when in file
    persistency mode.
  * Database upgrade rollback could fail.
  * Software version could be updated even if upgrade unsuccessful.
  * Topic names beginning with "Special:" should not be allowed, but topic
    names containing apostrophes should be allowed.
  * Categories and images no longer displayed on Special:Allpages.

Translation Updates:

  * Updated German translations from Axel Kramer (axelclk).
  * Updated Hungarian translations from bDaneE.

0.2.1
=====

New Features:

  * Support image resizing from [[Image]] tags.
  * Allow Wiki syntax in image and anchor link captions.
  * Update of the diff code to simplify the code and address some issues with
    diffs.
  * CSS fixes from Scott Croco (scroco).

Bugfixes:

  * Piped link within Wiki table syntax was displaying incorrectly.
  * Remove section edit links from printable page.
  * Fix XHTML issue related to extra <p> tag for images.

Translation Updates:

  * Updated Chinese translations from ewen0930.
  * Updated Hungarian translations from bDaneE.

0.2.0
=====

New Features:

  * Overhaul the search engine, make better use of Lucene for highlighting,
    delete numerous unneeded classes.
  * Add Special:LinkTo to display what links to the current page.
  * Drop commons-httpclient.jar - no longer used.
  * Upgrade to log4j 1.2.13.
  * Use <label> tag with form elements.
  * Upgrade javadiff from 1.0.3 to 1.0.4.
  * Upgrade Spring from 1.1.5 to 1.2.8.  Include only those components that
    are used by JAMWiki (saves over 500 kb).
  * Update commons-dbcp from 1.0 to 1.2.1.
  * Display file deletion information in recent changes.
  * Use syntax highlighting to denote change type on recent changes page,
    history page, and user contributions page.
  * Remove Special:OrphanedTopics - broken.
  * Remove Special:ToDoTopics - broken.
  * Better support for image alignment options.
  * Add build target for building source releases.
  * Search engine refresh no longer file-only.
  * Remove automatic search engine index rebuilding thread.
  * Automatically upgrade stylesheet and search index.
  * Code cleanups including removal of unused files.

Bugfixes:

  * Resolve setup bug in initialization code.
  * Fix image HTML display bug.
  * Correctly parse mailto: links.
  * "My Topic" and "My_Topic" should be treated as the same topic.
  * Do not display upgrade option after upgrade is complete.
  * Resolve additional cross-site scripting vulnerabilities reported by NickJ.
  * Title should be displayed on printable pages.
  * Do not allow \n, \r, ", ', >, <, {, }, #, /, \, [, ], or = in topic/user
    names.
  * Remove several hard-coded message strings, replace with messages that can
    be translated into local languages.

Translation Updates:

  * Updated Chinese translations from ewen0930.
  * Updated Hungarian translations from bDaneE.

0.1.3
=====

* BUG: Configuring a database with the "ansi" option failed and
  throws errors for subsequent database queries.
* FEATURE: Add better exception handling for errors thrown during the
  setup process.
* BUG: Fix Resin issue by making JAMWiki taglibs more standards-compliant.
* BUG: Fix Resin issue with CSS by not setting response encoding in
  the JAMWikiFilter.
* BUG: Update upgrade message to not escape URL.
* BUG: Update property file loading to fix WebSphere issue.

0.1.2
=====

* BUG: Resolve issue with non-ASCII characters for translated languages.
* BUG: Fix parser issues with lists followed by HTML or Wiki text.
* BUG: Fix style handling for Wiki tables.
* FEATURE: Implemented Wiki pre-formatted text syntax (space + text).
* BUG: Make parser paragraph handling more intelligent.
* BUG: Multiple empty lines of text should be parsed as empty paragraphs.
* BUG: Allow Wiki markup in headings.
* BUG: Do not display section edit links during preview.
* BUG: Fix numerous cross-site scripting vulnerability reported by NickJ.
* FEATURE: Remove numerous hard-coded message strings, including those
  thrown in exceptions.
* FEATURE: Updated Chinese and Hungarian translations from ewen0930 and
  bDaneE.
* FEATURE: Remove the RSS code.  Will be implemented differently in a
  future version of JAMWiki.
* FEATURE: Remove the "history list" code - it was unused.
* FEATURE: Move default topic pages into a language-specific directory
  to allow for future translations.
* FEATURE: Simplify the "Printable page" code, remove the option to print
  X number of pages.
* FEATURE: Make the generated HTML more XHTML compliant.

0.1.1
=====

* FEATURE: Minor edit status now stored and displayed.
* FEATURE: Add Special:Translation GUI for entering language translations.
* FEATURE: TopArea is no longer an editable topic - admin property
  added to set the logo image.
* BUG: Parser would allow Javascript in Wiki syntax.  Disabled unless
  explicitly enabled via the admin tool.
* FEATURE: Parser will reformat badly written HTML (such as "< sTriKe >").
* BUG: Parser is now more strict about what HTML is allowed.
* BUG: Edits could not be saved or previewed on non-English versions.
* BUG: Uploaded file sometimes includes full path from user's browser.
  Hopefully fixed (feedback requested).
* FEATURE: Add tabs to the admin pages to improve navigation.
* FEATURE: http://server/context/virtual/ redirects to default topic.
* FEATURE: Empty jamwiki.properties file removed from WAR file to prevent
  accidentally overwriting properties during upgrade.
* FEATURE: Move all SQL to property files.
* FEATURE: Remove copyvio'd background image from Mediawiki.  Existing
  JAMWiki installs will want to replace "headbg.jpg" in the StyleSheet
  topic with "denalibg.jpg".
* FEATURE: Keep ugly logo, but make background transparent.  Existing
  JAMWiki installs will want to replace "logo.jpg" in the StyleSheet
  topic with "logo.gif".
* FEATURE: Update HTTP cache headers.
* FEATURE: Use sans-serif as default font.
* FEATURE: More Chinese translations from Jiading (ewen0930).
* FEATURE: Hungarian translations from Daniel Tar (bDaneE).

0.1.0
=====

* FEATURE: Add support for editing sub-sections of a topic.
* FEATURE: Add support for transaction rollback to avoid
  half-committed edits from being saved (database only).
* FEATURE: Allow editing of old topic versions from the history tab
  (provides a way to rollback changes).
* FEATURE: Chinese translations from Jiading (ewen0930).
* FEATURE: Support Wiki links to a virtual wiki (for example
  [[:virtual:Topic]]).
* FEATURE: Allow each virtual wiki to have a different default topic
  (requested by colinbes)
* FEATURE: Add default_topic_name column to jam_virtual_wiki.  Upgrade
  should be automatic, so no manual SQL needs to be executed.
* FEATURE: Use a simpler page layout during setup/upgrade to avoid
  possible errors.
* FEATURE: Add logging for slow database queries.
* FEATURE: Do not display a textarea with Wiki syntax when viewing an old
  topic version.
* FEATURE: Cache CSS for 30 minutes rather than setting nocache.
* FEATURE: Add XHTML transitional doctype declaration.
* FEATURE: Remove navbar-virtual-wiki.jsp - not useful.
* BUG: Remove several hard-coded message strings, replace with messages that
  can be translated into local languages.
* FEATURE: Code cleanups including removal of unused files.

0.0.9
=====

* BUG: Fix infinite redirection error when installing.

0.0.8
=====

* BUG: File persistency broken on JDK 1.4 due to use of JDK 1.5 method.
  Should be resolved (feedback from JDK 1.4 users is requested).
* FEATURE: User passwords are now encrypted using the SHA-512 algorithm to
  add security.
* FEATURE: System should now automatically detect when JAMWiki has been
  upgraded and then attempt to perform any needed upgrade setup.
* FEATURE: Various code cleanups.
* BUG: Remove several hard-coded message strings, replace with messages that
  can be translated into local languages.

0.0.7
=====

* BUG: Handle non ISO-8859-1 characters properly.  May require additional
  configuration for some databases and application servers.  Issue reported
  by Alexey.
* BUG: Make web.xml and the taglib definitions more standards compliant.
  Note that this allows JAMWiki to run on Websphere.
* FEATURE: Remove topic locking & implement a new edit screen to allow for
  manual resolution of edit conflicts.
* FEATURE: Remove the old topic locking code including Special:LockList and
  Special:Unlock.
* BUG: Replace CHAR columns in database with INTEGER to fix a problem with
  the H2 database - BREAKS ANY EXISTING INSTALLATION! See the release notes
  for the database update syntax.
* FEATURE: Update to Alexey's new default style.
* FEATURE: Do not include CSS information inline, instead make jamwiki.css an
  editable Wiki topic and load from that.
* FEATURE: Hide passwords when updating values on the admin page.
* BUG: Resolved some table syntax parsing issues.
* BUG: If an error occurs the setup process might not create the
  StartingPoints topic.
* BUG: Admin-only topics not marked admin-only during setup.
* FEATURE: Recent changes and user contributions now have options to view
  latest 250 and 500 changes.
* BUG: If a topic is saved with no changes, do not save a new version.
* BUG: Remove redundant parsing code that was causing diffs to be shown
  when no diff was made.
* FEATURE: Remove the "Cancel" option from the edit page.
* FEATURE: Once setup is complete disable the setup screen.
* FEATURE: Add option to reload recent changes to the admin screen
  (database persistency only).
* FEATURE: Make more HTML code XHTML compliant.
* FEATURE: Code cleanups including removal of unused files.
* FEATURE: Default log level changed to "WARN".

0.0.6
=====

* FEATURE: Add support for uploading files and viewing them as images.
* FEATURE: Update the look & feel of the edit preview display.
* BUG: Shrink generated JSP class files by using <jsp:include>.  Resolves
  issues with Resin app server (reported by Alexi).
* BUG: Resolve issue of HTML characters being incorrectly escaped during
  edits.
* BUG: Only show the edit preview when the preview button is clicked.
* FEATURE: Hide the non-working Javascript edit buttons.
* BUG: Resolve more "fails to redirect after login" issues.
* FEATURE: Upgrade to commons-fileupload-1.1.1.jar.
* FEATURE: Add commons-io-1.2.jar.
* BUG: Add commons-logging-1.1.jar which is required by Spring.  Reported
  by Alexi.
* BUG: Update cache headers to resolve issues with Opera.  Reported with a
  suggested fix by Alexi.
* BUG: Author IP address not being retrieved in file persistency mode.
* FEATURE: Support Mediawiki image links ([[:Image:Foo]]).
* FEATURE: Display image file history for image pages.
* BUG: Remove several hard-coded message strings, replace with messages
  that can be translated into local languages.
* BUG: Fix file persistency to database persistency conversion.  Required
  removal of database sequences.
* FEATURE: Hide panic and email notification options in admin - not
  currently supported.
* FEATURE: Remove RSS link from the nav bar - not currently supported.
* FEATURE: Update database schema - BREAKS ANY EXISTING INSTALLATION!  See
  the release notes for the database update syntax.
* FEATURE: Code cleanups including removal of unused files.

0.0.5
=====

* FEATURE: Add support for MySql 4.1.
* FEATURE: Add support for Oracle 10g.
* FEATURE: Code cleanups including abstraction of database code.
* BUG: Do not allow directories to be created in the filesystem root during
  setup.
* BUG: User menu link for user was broken if display name not set.
* FEATURE: Hide Special:Attach - not currently supported.
* FEATURE: Display an explanation message on the login page when requiring
  login to an admin page.
* BUG: Login to Special:Delete went to Special:Admin.
* FEATURE: Log sql execution time info for debugging.
* FEATURE: Remove the "Admin" link from the footer, display in the user menu
  ONLY for users who are admins.
* FEATURE: Update database schema - BREAKS ANY EXISTING INSTALLATION!  See
  the release notes for the database update syntax.
* FEATURE: User contributions page now has the same style as the recent
  changes and history pages.
* FEATURE: Add unique constraints to several database fields.

0.0.4
=====

* FEATURE: Add "Account", "User" and "Comments" links to user navigation bar.
* FEATURE: Add "Remember Me" login option.
* FEATURE: Add ability to view all contributions made by a specific user
  (Special:Contributions).
* FEATURE: Add ability to update user account information.
* FEATURE: Change navbar search to default "Search", not "Jump to".
* FEATURE: "Comments" tab works now and is colored to reflect whether a
  comments page exists yet or not.
* FEATURE: Error handling added to avoid ugly stack traces being shown to
  end users and ensure that errors are logged.
* FEATURE: Support MediaWiki signatures - "~~~", "~~~~" and "~~~~~".
* FEATURE: Support MediaWiki "__TOC__" directive.
* FEATURE: Change Special:Registration URL to Special:Account.
* BUG: If user login required actually check for logged in user prior to
  editing.
* FEATURE: Hide LDAP and other unused / unsupported options in admin tool.
* FEATURE: Always encode passwords by default, remove option to have
  unencoded passwords.
* FEATURE: Code cleanups including deletion of unused code.  PDF search no
  longer supported.  War file size should now be about 450K smaller.
* FEATURE: New utility class for handling prepared statements.
* FEATURE: Added new WikiPageInfo class to hold basic page data.
* FEATURE: Utilize more of the Spring framework functionality, should ensure
  that cache headers always get set properly.
* FEATURE: Update from JFlex 1.3.5 to 1.4.1 - slightly faster.
* FEATURE: Add previous_topic_version_id column to jam_topic_version.  BREAKS
  ANY EXISTING INSTALLATION!  See the release notes for the database update
  syntax.
* BUG: "Article" tab from comments pages fixed.

0.0.3
=====

* FEATURE: Add support for user accounts.
* FEATURE: Added user registration and login pages.
* FEATURE: Record user information when editing for logged-in users.
* FEATURE: Setup now requires creation of a default admin account.
* FEATURE: Remove admin password option from admin pages.
* FEATURE: Top navigation now shows login/logout option.
* FEATURE: Code cleanups including deletion of unused code.  War file size
  should now be about 200K smaller.
* FEATURE: Remove and update several database field values.  BREAKS ANY
  EXISTING INSTALLATION!
* FEATURE: Include copy of LGPL in WAR file distribution.
* FEATURE: History page now displays author & edit comment.
* FEATURE: History & recent changes organization is now more like MediaWiki.
* FEATURE: Remove database setup options from Special:Upgrade.
* BUG: File handling of next_id values could sometimes cause error.
* BUG: Miscellaneous bugfixes.

0.0.2
=====

* FEATURE: Add admin page option for "Use table of contents".
* FEATURE: Code cleanups including deletion of unused code.
* BUG: Hash mark in a URL or topic (Topic#Section) was not being interpreted
  as a page section.
* BUG: Error creating topic link on recent changes page.
* BUG: Edit comment was being lost during preview.
* FEATURE: Add links to jamwiki.org in default setup.
* BUG: Fix link from logo.
* BUG: Background of external link image not transparent.
* BUG: Editing cached topic was not viewable until the second page view after
  the edit.
* FEATURE: Rename and reorganize database tables.  BREAKS ANY EXISTING
  INSTALLATION!
